<template>
  <div v-if="data">
    <div class="user-profile">
      <div class="user-profile__photo"><Avatar :user="data" :size="100" /></div>
      <div class="user-profile__name">{{ user_name(data.display_name) }}</div>
      <div class="user-profile__place">
        <svg-icon name="marker" />
        <div>
          {{
            [data.location.city, data.location.country]
              .filter(e => !!e)
              .join(', ')
          }}
        </div>
      </div>
      <!-- <div class="user-profile__favorites">like</div> -->
    </div>
    <div class="user-navigation">
      <ul>
        <li class="item">
          <nuxt-link :to="`/users/${$route.params.username}`"
            >Portfolio</nuxt-link
          >
        </li>
        <li class="item">
          <nuxt-link :to="`/users/${$route.params.username}/events`">
            Events
          </nuxt-link>
        </li>
        <!-- <li class="item">
          <nuxt-link :to="`/users/${$route.params.username}/places`">
            Places
          </nuxt-link>
        </li> -->
        <li class="item">
          <nuxt-link :to="`/users/${$route.params.username}/store`"
            >Store</nuxt-link
          >
        </li>
      </ul>
    </div>
    <Feed :data="media" variant="large" :counter="false" />
    <div v-if="!checkMore" style="margin-top: 25px; text-align: center">
      <Button @click="loadMore" size="inline">Load More</Button>
    </div>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  computed,
  useMeta,
  useAsync,
  useContext,
  onMounted,
  ref
} from '@nuxtjs/composition-api'
import { useGetMediaQuery, useGetUserPublicQuery } from '~/sdk/hooks'
import { MediaFileFragment } from '~/sdk/types'

import MainContainer from '@/components/ui/MainContainer.vue'
import Burger from '@/components/ui/Burger.vue'
import Feed from '@/components/ui/Feed.vue'
import Button from '@/components/ui/Button.vue'
import Avatar from '@/components/ui/Avatar.vue'
export default defineComponent({
  name: 'UserPage',
  props: ['data'],
  head: {},
  components: {
    Feed,
    Button,
    MainContainer,
    Burger,
    Avatar
  },
  setup(props, { root }) {
    const meta = useMeta()
    meta.title.value = props.data?.display_name
    meta.meta.value = [
      {
        hid: 'name',
        name: 'name',
        content: props.data?.display_name
      },
      {
        hid: 'description',
        name: 'description',
        content: props.data?.bio
      },
      {
        hid: 'image',
        property: 'image',
        content: `/storage/${props.data?.media_files_in_search[0].media_file.preview_url}`
      },
      {
        hid: 'og:image',
        property: 'og:image',
        content: `/storage/${props.data?.media_files_in_search[0].media_file.preview_url}`
      },
      {
        hid: 'og:title',
        property: 'og:title',
        content: props.data?.display_name
      },
      {
        hid: 'og:description',
        property: 'og:description',
        content: props.data?.bio
      }
    ]

    const { route, error } = useContext()
    const userId = route.value.params.id as string

    const user_name = (value: string) => {
      let str = value.split(' ')
      if (str[1]) return str[0] + ' ' + str[1].substr(0, 1) + '.'
      else return str[0]
    }

    const totalMedia = ref({
      all: 0,
      offset: 0,
      counter: 0,
      per_page: 8
    })
    const media = ref<MediaFileFragment[]>([])
    const { onResult: mediaResult, loading: mediaLoading } = useGetMediaQuery(
      computed(() => ({
        where: {
          album_id: { _is_null: true },
          event_id: { _is_null: true },
          user_id: { _eq: props.data.id }
        },
        limit: totalMedia.value.per_page,
        offset: totalMedia.value.offset
      }))
    )
    mediaResult(result => {
      if (result?.data?.media_files) {
        media.value.push(...result.data.media_files)
        totalMedia.value.all = result.data.count?.aggregate?.count as any
        totalMedia.value.counter = media.value.length
      }
    })
    const checkMore = computed(() => {
      return totalMedia.value.counter == totalMedia.value.all
    })
    const loadMore = () => {
      totalMedia.value.offset = +totalMedia.value.counter
    }

    return { user_name, media, checkMore, loadMore }
  }
})
</script>

<style lang="scss" scoped>
.user-profile {
  background: #272c3b;
  border-radius: 10px;
  padding: 45px 20px;
  text-align: center;
  &__photo {
    margin-bottom: 20px;
  }
  &__name {
    letter-spacing: -1.13px;
    color: #ffffff;
    font-size: 45px;
    line-height: 60px;
    font-weight: 900;
    margin-bottom: 10px;
  }
  &__place {
    display: inline-flex;
    align-items: center;
    letter-spacing: -0.5px;
    color: #ffffff;
    font-size: 20px;
    line-height: 24px;
    font-weight: bold;
    margin-bottom: 35px;
    &:last-child {
      margin-bottom: 0px;
    }
    svg {
      width: 20px;
      height: 20px;
      margin-right: 10px;
      fill: #8591ad;
    }
  }
}
.user-navigation {
  margin-top: 35px;
  margin-bottom: 40px;
  text-align: center;
  ul {
    margin: 0px;
    padding: 0px;
    list-style: none;
    display: inline-flex;
    overflow-x: auto;
    overflow-y: hidden;
    li {
      padding: 0 30px;
      a {
        letter-spacing: -1px;
        color: #8591ad;
        font-size: 40px;
        line-height: 40px;
        font-weight: bold;
        &.is-active {
          color: #fff;
        }
      }
    }
  }
}
</style>
